.a-button {
  padding: 0.5rem 1.25rem;
  box-shadow: 0.125rem 0.25rem 0.75rem var(--black-alpha-15);
  border: none;
  background-color: var(--black-100);
  color: var(--white);
  font-size: 0.9rem;
  font-weight: bold;
  border-radius: 0.5rem;
  cursor: pointer;
  transition: ease 0.15s transform, ease 0.25s opacity,
    ease 0.25s background-color;
  text-transform: uppercase;
  display: inline-flex;
  align-items: center;
  justify-content: center;
  opacity: 1;

  &__text {
    margin-right: 0.333rem;
  }

  &__icon {
    height: 1rem;
    width: 1.35rem;
    display: flex;
    align-items: center;

    mat-icon {
      transform: scale(0.9);
    }
  }

  &.-large {
    padding: 0.75rem 1.5rem;

    .a-button__icon {
      mat-icon {
        transform: scale(1.2);
      }
    }
  }

  &.-square {
    padding: 0.75rem;
  }

  &.-block {
    display: block;
    width: 100%;
    flex: 1 0 auto;
  }

  &.-no-shadow {
    box-shadow: unset;
  }

  &:hover {
    transform: scale(1.05);
    outline: none;
  }

  &:active {
    transform: scale(0.95);
  }

  &:disabled {
    cursor: not-allowed;
    transform: scale(1);
    opacity: 0.333;
  }

  &.-is-loading {
    position: relative;
    overflow: hidden;

    &::after {
      display: block;
      content: "";
      position: absolute;
      bottom: 0;
      left: -100%;
      width: 200%;
      height: 4px;
      background-image: linear-gradient(
        90deg,
        var(--theme-blue-primary) 0%,
        var(--theme-purple-primary) 12.5%,
        var(--theme-orange-primary) 25%,
        var(--theme-green-primary) 37.5%,
        var(--theme-blue-primary) 50%,
        var(--theme-purple-primary) 62.5%,
        var(--theme-orange-primary) 75%,
        var(--theme-green-primary) 87.5%,
        var(--theme-blue-primary) 100%
      );
      animation-name: is-loading;
      animation-duration: 1.5s;
      animation-timing-function: linear;
      animation-iteration-count: infinite;
    }
  }

  &.-white {
    background-color: var(--white);
    color: var(--black-100);
  }

  &.-warning {
    background-color: var(--functional-orange);
    color: var(--black-100);
  }

  &.-error {
    background-color: var(--functional-red);
  }

  &.-blue {
    background-color: var(--theme-blue-primary);
    background-image: linear-gradient(
      90deg,
      var(--theme-blue-primary) 0%,
      var(--theme-blue-secondary) 100%
    );
  }

  &.-purple {
    background-color: var(--theme-purple-primary);
    background-image: linear-gradient(
      90deg,
      var(--theme-purple-primary) 0%,
      var(--theme-purple-secondary) 100%
    );
  }

  &.-orange {
    background-color: var(--theme-orange-primary);
    background-image: linear-gradient(
      90deg,
      var(--theme-orange-primary) 0%,
      var(--theme-orange-secondary) 100%
    );
  }

  &.-green {
    background-color: var(--theme-green-primary);
    background-image: linear-gradient(
      90deg,
      var(--theme-green-primary) 0%,
      var(--theme-green-secondary) 100%
    );
  }
}
